---
title: History.pushState()
slug: Web/API/History/pushState
tags:
  - API
  - HTML DOM
  - History
  - History API
  - Location
  - Method
  - Reference
  - Session
  - URL
  - Web
  - pushState
---
<div>{{APIRef("History API")}}</div>

<p>In an <a href="/en-US/docs/Web/HTML">HTML</a> document, the <strong><code>history.pushState()</code></strong> method adds an entry to the browser's session history stack.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">history.pushState(<var>state</var>, <var>title</var> [, <var>url</var>])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>state</code></dt>
 <dd>The <code>state</code> object is a JavaScript object which is associated with the new history entry created by <code>pushState()</code>. Whenever the user navigates to the new <code>state</code>, a {{event("popstate")}} event is fired, and the <code>state</code> property of the event contains a copy of the history entry's <code>state</code> object.</dd>
 <dd>The <code>state</code> object can be anything that can be serialized. Because Firefox saves <code>state</code> objects to the user's disk so they can be restored after the user restarts the browser, we impose a size limit of 640k characters on the serialized representation of a <code>state</code> object. If you pass a <code>state</code> object whose serialized representation is larger than this to <code>pushState()</code>, the method will throw an exception. If you need more space than this, you're encouraged to use {{domxref("Window.sessionStorage", "sessionStorage")}} and/or {{domxref("Window.localStorage", "localStorage")}}.</dd>
 <dt><code>title</code></dt>
 <dd><a href="https://github.com/whatwg/html/issues/2174">Most browsers currently ignore this parameter</a>, although they may use it in the future. Passing the empty string here should be safe against future changes to the method. Alternatively, you could pass a short title for the state to which you're moving. If you need the title to be changed you could use {{domxref("Document.title", "document.title")}}.</dd>
 <dt><code>url</code> {{optional_inline}}</dt>
 <dd>The new history entry's URL is given by this parameter. Note that the browser won't attempt to load this URL after a call to <code>pushState()</code>, but it might attempt to load the URL later, for instance after the user restarts the browser. The new URL does not need to be absolute; if it's relative, it's resolved relative to the current URL. The new URL must be of the same {{glossary("origin")}} as the current URL; otherwise, <code>pushState()</code> will throw an exception. If this parameter isn't specified, it's set to the document's current URL.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>In a sense, calling <code>pushState()</code> is similar to setting <code>window.location = "#foo"</code>, in that both will also create and activate another history entry associated with the current document. But <code>pushState()</code> has a few advantages:</p>

<ul>
 <li>The new URL can be any URL in the same origin as the current URL. In contrast, setting {{domxref("window.location")}} keeps you at the same document only if you modify only the hash.</li>
 <li>You don't have to change the URL if you don't want to. In contrast, setting <code>window.location = "#foo";</code> only creates a new history entry if the current hash isn't <code>#foo</code>.</li>
 <li>You can associate arbitrary data with your new history entry. With the hash-based approach, you need to encode all of the relevant data into a short string.</li>
</ul>

<p>Note that <code>pushState()</code> never causes a {{event("hashchange")}} event to be fired, even if the new URL differs from the old URL only in its hash.</p>

<h2 id="Examples">Examples</h2>

<p>This creates a new browser history entry setting the <em>state</em>, <em>title</em>, and <em>url</em>.</p>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">const state = { 'page_id': 1, 'user_id': 5 }
const title = ''
const url = 'hello-world.html'

history.pushState(state, title, url)
</pre>

<h3 id="Change_a_query_parameter">Change a query parameter</h3>

<pre class="brush: js notranslate">const url = new URL(window.location);
url.searchParams.set('foo', 'bar');
window.history.pushState({}, '', url);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "history.html#dom-history-pushstate", "History.pushState()")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>No change from {{SpecName("HTML5 W3C")}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', "history.html#dom-history-pushstate", "History.pushState()")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.History.pushState")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/History_API/Working_with_the_History_API">Working with the History API</a></li>
 <li><a href="/en-US/docs/Web/API/Window/popstate_event">Window: popstate event</a></li>
</ul>
